
#define __cplusplus  201103L

#include "ESP32_VirtualFileSystem_to_WiFi_Budapest2021may17.h" ;
#include <WiFi.h>

using namespace std;

// change to your WiFi:
const char* ssid     = "*****";
const char* password = "********";

IPAddress ip(192, 168, 0, 20);
IPAddress dns(192, 168, 0, 1);
IPAddress gateway(192, 168, 0, 1);
IPAddress subnet(255, 255, 0, 0);

const char WEB[] PROGMEM = R"=====(HTTP/1.1 200 OK
Content-type:text/html
Connection: close

<!DOCTYPE html>
<html lang = hu > 
<head>
  <meta charset="UTF-8">
  <title>net file FS</title>
</head>
<body>
  <center>
    <h1>Hello world!</h1>
  </center>
</body> 
</html>


)=====";



void setup() {
  
  Serial.begin(115200);
  delay(3000);
  Serial.println("setup started");

  WiFi.begin(ssid, password);
  if(!WiFi.config(ip, gateway, subnet)) {
    Serial.println("Failed to configure");
  } ;
  WiFi.setSleep(false);
  Serial.print("Connecting to ");
  Serial.println(ssid);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());Serial.println("");
  Serial.print ("Try with browser http://");Serial.println(WiFi.localIP());
  Serial.print ("or client program with IP: ");Serial.println(WiFi.localIP());
  Serial.println("");

  WiFiFSinit() ;


//*****************************************************************************  

    printf ("\nRead from net ifstream sample:\n");

    ifstream file_ifstream;
    ofstream file_ofstream;    
    
  file_ifstream.open ("/server_fs/fajl.txt",  std::fstream::in );
  uint32_t cikl2 = 0 ;
  while ( !file_ifstream ){
  file_ifstream.open ("/server_fs/fajl.txt", std::ofstream::in   );
    cikl2++ ;
    if( (cikl2%100) == 0){
      printf ("\n file_fstream.open = false\n");       
    };
    delay(100);
  };   

  printf ("\n file_ifstream.open = OK\n"); 
  Serial.println("Receive on server:");
  char s[150] ;
  do {
    file_ifstream.getline (s, 100 );
    Serial.println(s);
  } while ( ! (s[0] == (char)13 ) );

  Serial.println("End received from server");

  file_ifstream.clear();


  file_ofstream.open ("/server_fs/fajl2.txt",  std::fstream::out );

  file_ofstream << WEB ;

  file_ofstream.flush();



  file_ofstream.close();
  file_ifstream.close();


//*****************************************************************************
/*  
      FILE* c_style_file_read;
      FILE* c_style_file_write;      
      Serial.println("wait c_style_file_read fopen");             
      do {
        c_style_file_read= fopen("/server_fs/file1","r");
        delay(1000);
//        Serial.println("wait c_style_file_read fopen");        
      
      } while (c_style_file_read == NULL);

      Serial.println("c_style_file_read fopen OK!");  
      Serial.println("Receive on server:");          
      char c;
      char buff [250] ;

      do {
              
        uint8_t i = 0 ;
        do {
          c = fgetc (c_style_file_read);
          //       Serial.print(c) ;
          buff[i]= c ;
          i++ ;
        } while (c != (char)10 );
        
        buff[i]= 0 ;
        Serial.print(buff);

      }  while( (buff[0]!= 13) );  // from browser wait for double
                                   //Carriage Return (CR) character (0x0D,13) 
                                   // or modify to your client program 

      Serial.println("End received from server") ;


      c_style_file_write= fopen("/server_fs/file2","w");

      fwrite ( WEB, sizeof( WEB), 1, c_style_file_write );
      fflush ( c_style_file_write );

      Serial.println("writed");

      fclose(c_style_file_read);
      fclose(c_style_file_write);  
*/
//*****************************************************************************  

} ;  // end setup

void loop() {

} ;
