
#include <esp_vfs.h>

extern  int client_fs_open (const char *path, int flags, int mode) ;
extern  int server_fs_open (const char *path, int flags, int mode) ;
extern  ssize_t  server_client_read(int fd, void* dst, size_t size) ;
extern  ssize_t  server_client_write(int fd, const void * data, size_t C) ; 
extern  int server_client_close(int fd) ;

esp_vfs_t esp_vfs_WiFi_server = {
      .flags = ESP_VFS_FLAG_DEFAULT,   // = 0
      .open  = &server_fs_open , 
      .write = &server_client_write ,
      .read  = &server_client_read ,
      .close = &server_client_close ,
};

esp_vfs_t esp_vfs_WiFi_client = {
      .flags = ESP_VFS_FLAG_DEFAULT,   // = 0
      .open  = &client_fs_open ,  
      .write = &server_client_write ,
      .read  = &server_client_read ,
      .close = &server_client_close ,
     
};

 
