#ifndef _DEVICE2VIRTUALFILESYSTE_H
#define _DEVICE2VIRTUALFILESYSTE_H

#define __cplusplus  201103L
#include <iostream>
#include <fstream>
#include <esp_vfs.h>
#include <WiFi.h>

  extern WiFiServer serverFS ;

  extern esp_vfs_t esp_vfs_WiFi_server ;
  extern esp_vfs_t esp_vfs_WiFi_client ;

  extern	"C" int client_fs_open (const char *path, int flags, int mode) ;
  extern  "C" int server_fs_open (const char *path, int flags, int mode) ;
  extern	"C" ssize_t  server_client_read(int fd, void* dst, size_t size) ;
  extern  "C" ssize_t  server_client_write(int fd, const void * data, size_t C) ;	
  extern	"C" int server_client_close(int fd) ;

  void WiFiFSinit() ;

#endif
